# FAQ

1. Появляется ошибка, в которой есть текст: "Неизвестный идентификатор формы". Это означает, что есть два или более epf файла, у которых совпадает поле **Имя** (это которое находится около Синонима и Комментария).

1. При открытии внешних обработок могут появляться окна с предупреждениями безопасности.
	* Если вы используете версию платформы 8.3.9.2033 или новее, тогда может появиться окно **Предупреждение безопасности**.
	* Подробно этот механизм описан [здесь](http://its.1c.ru/db/v838doc#bookmark:dev:TI000001871).
	* Решение описано по [ссылке](https://github.com/xDrivenDevelopment/precommit1c#%D0%94%D0%BB%D1%8F-%D0%BA%D0%BE%D1%80%D1%80%D0%B5%D0%BA%D1%82%D0%BD%D0%BE%D0%B9-%D1%80%D0%B0%D0%B1%D0%BE%D1%82%D1%8B-%D0%BD%D0%B0-1%D0%A1-%D0%B2%D0%B5%D1%80%D1%81%D0%B8%D0%B8-8392016-%D0%B8-%D1%81%D1%82%D0%B0%D1%80%D1%88%D0%B5)
		* Кратко - Если хотите выключить этот механизм для всех баз - пропишите в файле conf.cfg строку: **DisableUnsafeActionProtection=.***

1. При пакетном запуске не загружаются и не выполняются фичи, открывается только форма `bddRunner`

	* У Вас неверный/устаревший/ json-файл настроек, несовместимый формат со штатным json, например, что читает 1С :frowning:
	* например:
		* одинарный слеш `\` не разрешен - используйте или `\\` или `/`
		* или одинарные кавычки \` или ’ не разрешены - используйте `\"`
		* Пример правильной настройки

```json
		"КомандаСделатьСкриншот": "\"C:\\Program Files (x86)\\IrfanView\\i_view32.exe\" /capture=1 /convert=",
```

	* Разбор проблемы в https://xdd.silverbulleters.org/t/pri-paketnom-zapuske-ne-zagruzhayutsya-i-ne-vypolnyayutsya-fichi-otkryvaetsya-tolko-bddrunner/2132

4. Как поставить точку останова (брейкпоинт) во внешней обработке для отладки?
	* Используйте штатный механизм отладки 1С, если у вас
	  * файловая база
	  * или клиент 1С и сервер 1С находятся на одной машине.
	* Если это не так, тогда более сложный путь:
		* Надо закрыть сеанс TestManager.
		* Надо открыть сеанс TestManager.
		* Надо открыть через меню `Файл / Открыть файл` обработку, в которой стоит точка останова.
		* Только после пункта 3 надо открыть bddRunner.epf.
		* Теперь остановка на точке остановки во внешнией обработке будет работать. Но до первого изменений кода в ней. Если изменили код, то надо повторить все действия с начала.

1. Как вызвать код плагина на сервере при запуске в управляемой форме?

* Все просто.
* Практически любой плагин можно подключать на сервере
* Например:

```bsl
	ЗапросыИзБД = ВнешниеОбработки.Создать("ЗапросыИзБД");
	ЗапросыИзБД.ПолучитьКоличествоЭлементовСправочникаПоОтбору(...);

	Ожидаем = ВнешниеОбработки.Создать("УтвержденияBDD");
	Ожидаем.Что(Значение, "Должно быть равно 5, а это не так!").
		Равно(5);
```

* Небольшое ограничение - нужно помнить, что на сервере нет состояний, поэтому плагины запускаются без состояния.

6. Как работать с файлами внутри тестов/шагов? Как получить путь к текущему файлу или к файлу, рядом с ним?

Два варианта:
- Используйте организацию файлов через рабочий каталог проекта (**рекомендуемый путь**)
	- В BDD – `Ванесса.Объект.КаталогПроекта`
	- В TDD - `КонтекстЯдра.Объект.КаталогПроекта`
	- эта настройка задается
		- либо через командную строку (например, через `vanessa-runner`)
		- либо интерактивно, через форму настроек (`Сервис`)
-
- В TDD можно использовать получить полный путь к текущему файлу теста
	– в тесте нужно определить свойство «ПутьКФайлуПолный»
		- это или Глобальная публичная переменная модуля
		- или реквизит обработки (для серверных модулей)
	- В этой переменной будет клиентский путь к файлу теста
	- Переменная доступна как на этапе заполнения набора/списка тестов, так и при выполнении

- В BDD также можно использовать шаг `И я буду выбирать внешний файл "ИмяФайла"` для подмены интерактивных действий пользователя по выбору файла/каталога в окне выбора файлов/каталогов

7. Как пропустить сценарий, чтобы он не падал?
	* Можно его закоментировать в тексте фичи (символ #)
	* Можно поставить сценарию тег - и использовать теги фильтры
	* Да пусть падает - тем более если он не реализован - то он будет желтым, а если реализован - тогда почему он падает?

2. Как запустить фичу из поставки VB у себя в базе?
	* Большинство фич, которые идут в поставке VB, требуют, чтобы их запускали в специальной служебной базе.
	* Надо собрать служебную базу. Для этого надо загрузить CF из (**.\vanessa-behavoir\lib\CF\83**)
	* Надо руками в базе установить константу **Путь к  Vanessa Behavior** - это полный путь к обработке **vanessa-behavior.epf** включая имя файла
	* Надо открыть в базе VB
	* Надо указать тег исключение **IgnoreOnCIMainBuild** (список исключаемых тегов)
	* Для ОФ надо ещё указать тег **IgnoreOnOFBuilds**
	* После этого можно загружать все фичи из каталога фич и запускать на выполнение.

3. Как мне удалить в транзакции созданные данные?
	* В BDD не обязательно их удалять за собой.
	* Если всё же хотите,  Вы можете гарантированно удалить их в процедуре **ПередОкончаниемСценария()**. Она срабатывает в любом случае, даже если сценарий упал.
	* Если создавались данные из макета **(Данные = Ванесса.СоздатьДанныеПоТабличномуДокументу(Макет))**, то можно использовать метод **Ванесса.УдалитьСозданныеДанные(Данные)**.
	* Лучше стремиться к тому, чтобы сценарий сам обеспечивал себе окружение, чтобы успешно выполниться.

4. Где мне лучше создавать служебные данные для выполнения сценария?
	* В секции Контекст feature файла
	* В процедуре **ПередНачаломСценария()**

5. Если в сценарии возникла ошибка, модальное окно и т.д. - как мне гарантированно закрыть все эти окна, чтобы следующий сценарий не падал?
	* В секции контекст надо добавить шаг **И Я закрыл все окна клиентского приложения**. А ещё лучше создать экспортный сценарий и в него добавить этот шаг. А в секции Контекст вызывать экспортный сценарий.

6. Как проверять поведение системы под разными ролями?
	* Надо запустить несколько TestClient на разных портах и переключаться между ними.

7. Как сохранять скриншоты при ошибках сценариев?

	Интерактивная настройка:
		+ Закладка `Сервис`
		+ далее `Автоинструкции`
		+ поле `Консольная команда создания скриншотов`
		  + после строки команды вставляется имя файла и в таком виде команда запускается!

	Можно устанавливать
	+ как `NirCMD`
	+ http://www.nirsoft.net/utils/nircmd.zip
		+ команда `nircmd savescreenshot `

	+ так и `IrfanView`
		+ команда `"C:\Program Files (x86)\IrfanView\i_view32.exe" /capture=1 /convert=`
		+ команда
```json
		"\"C:\\Program Files (x86)\\IrfanView\\i_view32.exe\" /capture=1 /convert=",
```

	+ Важно только устанавливать 32-разрядные версии !!

	Примеры json-файла настройки фиксации скриншотов
		для `NirCMD`:

```json
	"ДелатьСкриншотПриВозникновенииОшибки": true,
	"СниматьСкриншотКаждогоОкна1С": true,
	"КаталогOutputСкриншоты": "$workspaceRoot/build/out/ScreenShots",
	"КомандаСделатьСкриншот": "nircmd savescreenshot "
```

	или для `IrfanView`:

```json
	"ДелатьСкриншотПриВозникновенииОшибки": true,
	"СниматьСкриншотКаждогоОкна1С": true,
	"КаталогOutputСкриншоты": "$workspaceRoot/build/out/ScreenShots",
	"КомандаСделатьСкриншот": "\"C:\\Program Files (x86)\\IrfanView\\i_view32.exe\" /capture=1 /convert=",
```

13. На CI сервере скриншот формируется, но вместо изображения чёрный экран. Как настроить сервер CI?
	* Запускать джоб Jenkins в режиме сервиса нельзя. На CI надо настроить автовход под какой либо учётной записью и в автозагрузку надо поместить команду запуска джоба Jenkins.
	* Нельзя использовать для доступа к CI RDP. Вообще. Надо использовать другой софт для удаленного доступа к нему, например TightVNC. RDP полностью гасит видеокарту (виртуальную или настоящую) при отключении.
	* Надо посмотреть схему энерго сбережения в панели управления, там может стоять отключение дисплея через пару минут. Это надо выключить.

1. Почему у меня не работает тэг `@tree`
	* Для работы тега `@tree` надо использовать либо только табы, либо только пробелы. В пределах одной  фичи нельзя в отступах строк использовать и пробелы и Табы.

1. Я подключаюсь по RDP к серверу. И фича выполняется нормально, но если свернуть окно RDP, то возникает ошибка.
	* Это связано с особенностью платформы 1С. Некоторые методы платформы (кнопконажималки) не работают, когда погашена видеокарта (а RDP клиент её гасит, когда вы его сворачиваете). Поэтому не надо использовать RDP для доступа к CI (или другим) серверам, когда вы хотите использовать кнопконажималку.

1. Я вызвал метод Ванесса.ЗапретитьВыполнениеШагов(), затем я подключаю свой таймер, и мне надо сделать, чтобы шаг упал.
	* в этом случае вместо вызова исключения надо сделать Ванесса.ПродолжитьВыполнениеШагов(Истина)

1. Как использовать Sikuli-скрипты.
	* Установите SikuliX согласно инструкции http://sikulix.com/quickstart/;
	* Ознакомьтесь с http://sikulix-2014.readthedocs.io/en/latest/faq/010-command-line.html;
	* Укажите через path путь к каталогу с runsikulix(.cmd);
	* Разрабатывайте свои Sikuli-скрипты с помощью SikuiliX IDE (http://sikulix-2014.readthedocs.io/en/latest/index.html) либо используйте имеющиеся;
	* Выполнение скрипта в реализации шага вызывайте через Ванесса.ВыполнитьSikuliСкрипт().

1. Как получить отчет Allure у себя на компьютере под Windows
	* Надо скачать дистрибутив Allure [отсюда](https://github.com/allure-framework/allure1/releases)
	* Надо прописать в Path каталог где лежит allure.bat
	* Для использования через командную строку можно использовать строки ниже
		* Вызвать команду **call allure generate {каталог где лежат ваши xml в формате Allure}**
		* Вызвать команду **call allure report open**
	* или установить флаг "Показать отчет Allure в браузере" на закладке `Сервис - отчет о запуске сценариев` и сохранить настройки
		* в этом случае после выполнения тестов и формирования отчетов Allure BDDRunner самостоятельно выполнит обе команды и покажет отчет Allure в браузере
	* или выполнить команду `Внешние инструменты - Отобразить отчет Allure в браузере`

1. Как при возникновении ошибки на CI получить скриншоты всех окон 1С?
	* Пока эта фича работает только под Windows.
	* Надо в json файле, в котором указываются параметры запуска Vanessa-Behavior, указать строку: `"СниматьСкриншотКаждогоОкна1С": "Истина"`
	* Надо установить на CI сервер java 8 (если у вас Jenkins - то скорее всего она у вас уже есть)
	* Надо установить SikuliX версии 1.1 или выше. Брать [отсюда](https://launchpad.net/sikuli/sikulix/1.1.1). Там надо скачать sikulixsetup-1.1.1.jar.
	* Надо чтобы файл runsikulix.cmd был прописан в переменной PATH.

1. Как для УФ (управляемой формы) и ОФ (обычной формы) шаги сделать общими?

* Разместить код шага в модуле объекта обработки,
* В коде управляемой формы в клиентском методе шага нужно вызвать серверный метод,
  * в котором выполнить `ОбъектНаСервере = ЗначениеФормыВОбъект("Объект")`
  * и вызвать код из модуля обработки `ОбъектНаСервере.НужныйМетод(...)`
* Сигнатуры методов в УФ и ОФ должны совпадать соответственно

21. Что нужно сделать, чтобы увидеть собственные шаги в форме `Известные шаги` ?

* В строке описания шага нужно заполнить последние параметры (4 и 5 параметры) в процедуре ДобавитьШагВМассивТестов. Там как раз задается развернутое описание шага и место в дереве.
* Место в группе можно задавать с учетом иерархии.
  * Указание группы как `UI.Формы.Кнопки.Мой шаг` расположит шаг в иерархии дерева `UI` - `Формы` - `Кнопки`
* Например,

```bsl
	Ванесса.ДобавитьШагВМассивТестов(ВсеТесты, "Пауза(Парам01)","Пауза", "И     Пауза 1",
		"Позволяет сделать паузу нужной длительности.", "Прочее.Сделать паузу");
```

22. Как быстро выполнить одну фичу или фичи из одного каталога?

* Правильнее запускать фичи из командной строки с помощью инструмента [Vanessa-Runner](https://github.com/silverbulleters/vanessa-runner)
* Для прогона одной фичи используйте команду
```bsl
	vrunner vanessa --settings tools\vrunner.json --path ПутьКФиче
```
или
```bsl
	vrunner vanessa --settings tools\vrunner.json --path ПутьККаталогуФич
```

где 
* `tools\vrunner.json` - путь к файлу настройки запуска, документированный в [readme.md](readme.md#файлы-настройкипрофиля-запуска-обработки)
* а `ПутьКФиче` или `ПутьККаталогуФич` - прямые или относительные пути к конкретной фиче или каталогу с фичами

